;**********************************************************************
;                                                                     *
; Programme BCD / Gray / 7 segments	        					      *
;                                                                     *
;**********************************************************************
;                                                                     *
;    NOM: CODE001.ASM    		                                      *
;    Date: 05/07/2005                                                 *
;    Version: 1.0                                                     *
;    Circuit: Programmateur/testeur ANCR                              *
;    Auteur: P. Lucidarme                                             *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fichier requis: P16F84.inc                                       *
;                                                                     *
;                                                                     *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Affiche les 16 caractres sur l'afficheur. 				      *
;                												      *
;**********************************************************************


; Prcise le PIC utilis

	LIST p=16F84

; Inclue la bibliothque p16F84.in fournie avec MPLAB

	#include <p16F84.inc>

; Prcise les options de programmation
; Pas de watchdog
; Power ON
; Oscillateur HS

	__CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON & _HS_OSC


; Dfinie 2 macro pour le changement de Bank

BANK0		macro
			bcf STATUS , RP0
			ENDM

BANK1 		macro
			bsf STATUS , RP0
			ENDM

Tempo		macro
			movlw D'7'
			call tempolong
			ENDM	

Aff_0 		macro
			movlw	b'11111100'
			movwf	PORTB
			ENDM

Aff_1 		macro
			movlw	b'01100000'
			movwf	PORTB
			ENDM

Aff_2 		macro
			movlw	b'11011010'
			movwf	PORTB
			ENDM

Aff_3 		macro
			movlw	b'11110010'
			movwf	PORTB
			ENDM

Aff_4 		macro
			movlw	b'01100110'
			movwf	PORTB
			ENDM

Aff_5 		macro
			movlw	b'10110110'
			movwf	PORTB
			ENDM

Aff_6 		macro
			movlw	b'10111110'
			movwf	PORTB
			ENDM

Aff_7 		macro
			movlw	b'11100000'
			movwf	PORTB
			ENDM

Aff_8 		macro
			movlw	b'11111110'
			movwf	PORTB
			ENDM

Aff_9 		macro
			movlw	b'11110110'
			movwf	PORTB
			ENDM

Aff_A 		macro
			movlw	b'11101110'
			movwf	PORTB
			ENDM

Aff_B 		macro
			movlw	b'00111110'
			movwf	PORTB
			ENDM

Aff_C 		macro
			movlw	b'10011100'
			movwf	PORTB
			ENDM

Aff_D 		macro
			movlw	b'01111010'
			movwf	PORTB
			ENDM

Aff_E 		macro
			movlw	b'10011110'
			movwf	PORTB
			ENDM

Aff_F 		macro
			movlw	b'10001110'
			movwf	PORTB
			ENDM

Aff_ 		macro
			movlw	b'00000000'
			movwf	PORTB
			ENDM

QuitTest	macro
			btfss	PORTA,4
			return
			btfss	PORTB,0
			return
			ENDM
		
; Dfinit les variables

	CBLOCK 		0x00C  		; dbut de la zone variables
	tempo1		: 1		
	tempo2		: 1
	tempo3		: 1

	Input		: 1
	ENDC


; Ddut du programme

	org 	0x000
	goto    init


; COnfiguration des ports en entre/sortie
; 0=sortie 1=entre

init
	
	CLRF	PORTA			; Met le port A en entre
	BANK1
	MOVLW	b'11111111'
	MOVWF   TRISA
	CLRF	PORTB			; Met le port B en sortie sauf le bit de poids faible
	BANK1
	MOVLW	b'00000001'
	MOVWF   TRISB
	BANK0
	clrf	PORTA			; Met tout le Port A  0
	clrf	PORTB			; Met tout le Port B  0

 ;********* DEBUT PROGRAMME PRINCIPAL ***********




MainLoop


	btfss	PORTA,4
	goto	Next1
	btfss	PORTB,0
	goto	Next1

	Call	Test
	goto	MainLoop
Next1

	btfsc	PORTB,0
	goto	Next2
	btfsc	PORTA,4
	goto	Next2

	Call Binary
	goto	MainLoop
Next2

	btfsc	PORTB,0
	goto	Next3
	btfss	PORTA,4
	goto	Next3
	
	call	BCD
	goto	MainLoop

Next3
	call	Gray

	goto	MainLoop


Binary

	movfw	PORTA
	movwf	Input
	movlw	b'00001111'
	ANDWF	Input,f
	incf	Input,f

	decfsz	Input,f
	goto	Jump1
	Aff_0
	return

Jump1	
	decfsz	Input,f
	goto	Jump2
	Aff_1
	return

Jump2
	decfsz	Input,f
	goto	Jump3
	Aff_2
	return
	
Jump3
	decfsz	Input,f
	goto	Jump4
	Aff_3
	return

Jump4
	decfsz	Input,f
	goto	Jump5
	Aff_4
	return

Jump5
	decfsz	Input,f
	goto	Jump6
	Aff_5
	return

Jump6
	decfsz	Input,f
	goto	Jump7
	Aff_6
	return

Jump7
	decfsz	Input,f
	goto	Jump8
	Aff_7
	return

Jump8
	decfsz	Input,f
	goto	Jump9
	Aff_8
	return

Jump9
	decfsz	Input,f
	goto	JumpA
	Aff_9
	return

JumpA
	decfsz	Input,f
	goto	JumpB
	Aff_A
	return

JumpB
	decfsz	Input,f
	goto	JumpC
	Aff_B
	return

JumpC
	decfsz	Input,f
	goto	JumpD
	Aff_C
	return

JumpD
	decfsz	Input,f
	goto	JumpE
	Aff_D
	return

JumpE
	decfsz	Input,f
	goto	JumpF
	Aff_E
	return

JumpF
	Aff_F
	return

Gray

	movfw	PORTA
	movwf	Input
	movlw	b'00001111'
	ANDWF	Input,f
	incf	Input,f

	decfsz	Input,f
	goto	GrayJump1	
	Aff_0	;0000
	return

GrayJump1	
	decfsz	Input,f
	goto	GrayJump2
	Aff_1	; 0001
	return

GrayJump2
	decfsz	Input,f
	goto	GrayJump3
	Aff_3	; 0010
	return
	
GrayJump3
	decfsz	Input,f
	goto	GrayJump4
	Aff_2	; 0011
	return

GrayJump4
	decfsz	Input,f
	goto	GrayJump5
	Aff_7	; 0100
	return

GrayJump5
	decfsz	Input,f
	goto	GrayJump6
	Aff_6	; 0101
	return

GrayJump6
	decfsz	Input,f
	goto	GrayJump7
	Aff_4	; 0110
	return

GrayJump7
	decfsz	Input,f
	goto	GrayJump8
	Aff_5	; 0111
	return

GrayJump8
	decfsz	Input,f
	goto	GrayJump9
	Aff_F	; 1000
	return

GrayJump9
	decfsz	Input,f
	goto	GrayJumpA
	Aff_E	; 1001
	return

GrayJumpA
	decfsz	Input,f
	goto	GrayJumpB
	Aff_C	; 1010
	return

GrayJumpB
	decfsz	Input,f
	goto	GrayJumpC
	Aff_D	; 1011
	return

GrayJumpC
	decfsz	Input,f
	goto	GrayJumpD
	Aff_8	; 1100
	return

GrayJumpD
	decfsz	Input,f
	goto	GrayJumpE
	Aff_9	; 1101
	return

GrayJumpE
	decfsz	Input,f
	goto	GrayJumpF
	Aff_B	; 1110
	return

GrayJumpF
	Aff_A
	return




BCD

	movfw	PORTA
	movwf	Input
	movlw	b'00001111'
	ANDWF	Input,f
	incf	Input,f
	decfsz	Input,f
	goto	BCDJump1
	Aff_0
	return

BCDJump1	
	decfsz	Input,f
	goto	BCDJump2
	Aff_1
	return

BCDJump2
	decfsz	Input,f
	goto	BCDJump3
	Aff_2
	return
	
BCDJump3
	decfsz	Input,f
	goto	BCDJump4
	Aff_3
	return

BCDJump4
	decfsz	Input,f
	goto	BCDJump5
	Aff_4
	return

BCDJump5
	decfsz	Input,f
	goto	BCDJump6
	Aff_5
	return

BCDJump6
	decfsz	Input,f
	goto	BCDJump7
	Aff_6
	return

BCDJump7
	decfsz	Input,f
	goto	BCDJump8
	Aff_7
	return

BCDJump8
	decfsz	Input,f
	goto	BCDJump9
	Aff_8
	return

BCDJump9
	decfsz	Input,f
	goto	BCDJump
	Aff_9
	return

BCDJump
	Aff_
	return



Test

; Test de la maquette
	Aff_
	Tempo
	QuitTest

	Aff_0
	Tempo
	QuitTest

	Aff_1
	Tempo
	QuitTest

	Aff_2
	Tempo
	QuitTest

	Aff_3
	Tempo
	QuitTest

	Aff_4
	Tempo
	QuitTest

	Aff_5
	Tempo
	QuitTest

	Aff_6
	Tempo
	QuitTest

	Aff_7
	Tempo
	QuitTest

	Aff_8
	Tempo
	QuitTest

	Aff_9
	Tempo
	QuitTest

	Aff_A
	Tempo
	QuitTest

	Aff_B
	Tempo
	QuitTest

	Aff_C
	Tempo
	QuitTest

	Aff_D
	Tempo
	QuitTest

	Aff_E
	Tempo
	QuitTest

	Aff_F
	Tempo


	return

 ;********* FIN PROGRAMME PRINCIPAL ***********



;*********************************************************************
;                            SUB-ROUTINES                            *
;*********************************************************************


			; Delay = W * 78ms
			;-------------------


tempolong	MOVWF   tempo3		; Met la valeur de W dans la variable tempo3
loop4		MOVLW	0xFF		; Charge 256 dans W
		CALL	tempo		; Appelle tempo
		DECFSZ	tempo3,F	; On dcrmente tempo3, on est arriv  0 ?
  		GOTO	loop4		; Non, on continu vers loop 4
		RETURN			; Oui, on sort

			; Delay = W * 304us
			;-------------------

tempo		MOVWF   tempo2		; Met la valeur de W dans la variable tempo2
loopnormal	MOVLW	0xFF		; Charge 256 dans W
		CALL	temposhort	; Appelle temposhort
		DECFSZ	tempo2,F	; On dcrmente tempo2, on est arriv  0 ?
  		GOTO	loopnormal	; Non, on continu vers loopnormal
		RETURN			; Oui, on sort

			; Delay = W * 1.2us
			;-------------------


temposhort	MOVWF   tempo1		; Met la valeur de W dans la variable tempo1
loopshort	DECFSZ	tempo1,F	; On dcrmente tempo1, on est arriv  0 ?
  		GOTO	loopshort	; Non, on continu vers loopshort
		RETURN			; Oui, on sort



		END 			; directive fin de programme

